#pragma once
#ifndef PARSODUS_FIRSTSET_H_Q6U5VBG0
#define PARSODUS_FIRSTSET_H_Q6U5VBG0

#include <map>
#include <set>
#include <string>
#include <vector>

namespace pds {

struct Grammar;

namespace util {

class FirstSet {
    public:
        FirstSet(const Grammar& g);

        /**
         * Get the first set for the given symbol
         */
        std::set<std::string> operator()(std::string key) const;

        /**
         * Get the first set for the given sequence of symbols
         */
        std::set<std::string> operator()(std::vector<std::string> sequence) const;
        

    private:
        std::map<std::string, std::set<std::string>> m_first;
};

} /* util  */ 
} /* pds */

#endif /* PARSODUS_FIRSTSET_H_Q6U5VBG0 */
